Loading...
Searching...
No Matches
IDableBpGraphComponent< BAS > Class Template Reference

## Detailed Description

template<typename BAS = BaseBpGraphComponent>
class lemon::concepts::IDableBpGraphComponent< BAS >

This class describes the interface of idable undirected bipartite graphs. It extends IDableGraphComponent with the core ID functions of undirected bipartite graphs. Beside the regular node ids, this class also provides ids within the the red and blue sets of the nodes. This concept is part of the BpGraph concept.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for IDableBpGraphComponent< BAS >:
[legend]

## Public Member Functions

int | id (const RedNode &) const
| Return a unique integer id for the given node in the red set.
int | id (const BlueNode &) const
| Return a unique integer id for the given node in the blue set.
int | maxRedId () const
| Return an integer greater or equal to the maximum node id in the red set.
int | maxBlueId () const
| Return an integer greater or equal to the maximum node id in the blue set.
int | id (const Edge &) const
| Return a unique integer id for the given edge.
Public Member Functions inherited from IDableGraphComponent< BaseBpGraphComponent >
int | id (const Edge &) const
| Return a unique integer id for the given edge.
Edge | edgeFromId (int) const
| Return the edge by its unique id.
int | maxEdgeId () const
| Return an integer greater or equal to the maximum edge id.
Public Member Functions inherited from IDableDigraphComponent< BaseBpGraphComponent >
int | id (const Node &) const
| Return a unique integer id for the given node.
Node | nodeFromId (int) const
| Return the node by its unique id.
Arc | arcFromId (int) const
| Return the arc by its unique id.
int | maxNodeId () const
| Return an integer greater or equal to the maximum node id.
int | maxArcId () const
| Return an integer greater or equal to the maximum arc id.
Public Member Functions inherited from BaseBpGraphComponent
bool | red (const Node &) const
| Gives back true for red nodes.
bool | blue (const Node &) const
| Gives back true for blue nodes.
RedNode | redNode (const Edge &) const
| Gives back the red end node of the edge.
BlueNode | blueNode (const Edge &) const
| Gives back the blue end node of the edge.
RedNode | asRedNodeUnsafe (const Node &) const
| Converts the node to red node object.
BlueNode | asBlueNodeUnsafe (const Node &) const
| Converts the node to blue node object.
RedNode | asRedNode (const Node &) const
| Converts the node to red node object.
BlueNode | asBlueNode (const Node &) const
| Converts the node to blue node object.
Public Member Functions inherited from BaseGraphComponent
Node | u (const Edge &) const
| Return one end node of an edge.
Node | v (const Edge &) const
| Return the other end node of an edge.
Arc | direct (const Edge &, bool) const
| Return a directed arc related to an edge.
Arc | direct (const Edge &, const Node &) const
| Return a directed arc related to an edge.
bool | direction (const Arc &) const
| Return the direction of the arc.
Arc | oppositeArc (const Arc &) const
| Return the opposite arc.
Public Member Functions inherited from BaseDigraphComponent
Node | source (const Arc &) const
| Return the source node of an arc.
Node | target (const Arc &) const
| Return the target node of an arc.
Node | oppositeNode (const Node &, const Arc &) const
| Return the opposite node on the given arc.

## Additional Inherited Members

Public Types inherited from BaseDigraphComponent
typedef GraphItem< 'n'> | Node
| Node class of the digraph.
typedef GraphItem< 'a'> | Arc
| Arc class of the digraph.

## Member Function Documentation

## id() [1/3]

template<typename BAS = BaseBpGraphComponent>

int id | ( | const RedNode & |  | ) | const

inline

Return a unique integer id for the given node in the red set.

## id() [2/3]

template<typename BAS = BaseBpGraphComponent>

int id | ( | const BlueNode & |  | ) | const

inline

Return a unique integer id for the given node in the blue set.

## maxRedId()

template<typename BAS = BaseBpGraphComponent>

int maxRedId | ( |  | ) | const

inline

Return an integer greater or equal to the maximum node id in the red set.

## maxBlueId()

template<typename BAS = BaseBpGraphComponent>

int maxBlueId | ( |  | ) | const

inline

Return an integer greater or equal to the maximum node id in the blue set.

## id() [3/3]

template<typename BAS = BaseBpGraphComponent>

int id | ( | const Edge & |  | ) | const

inline

This function returns a unique integer id for the given edge.